//
//  searchBarSecondTypeView.m
//  隐私保护
//
//  Created by xd h on 2025/3/18.
//

#import "searchBarSecondTypeView.h"

@interface searchBarSecondTypeView ()<UITextFieldDelegate>
@property(nonatomic,strong) UITextField*searchTF;
@property(nonatomic,strong) UIButton*searchButton;
@end

@implementation searchBarSecondTypeView

- (id)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    
    //self.backgroundColor = [UIColor clearColor];
    [self drawAnyView];
    
    return self;
}

-(void)drawAnyView
{
    UIView *whiteBgView = [[UIView alloc] init];
    whiteBgView.backgroundColor = [UIColor hwColor:@"#F9F9F9"];
    [self addSubview:whiteBgView];
    whiteBgView.layer.cornerRadius = 8;
    whiteBgView.layer.masksToBounds = YES;
    
    [whiteBgView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(0);
        make.left.mas_equalTo(0);
        //make.right.mas_equalTo(0);
        make.right.mas_equalTo(-48);
        make.bottom.mas_equalTo(0);
    }];
    
    //添加手势事件
    [whiteBgView addGestureRecognizer:[[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(didClickWhiteViewFun)]];
    
    //搜索小图标
    UIImageView *imageView = [[UIImageView alloc] init];
    imageView.image = [UIImage imageNamed:@"home_search_icon"];
    [whiteBgView addSubview:imageView];
    
    [imageView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(24);
        make.height.mas_equalTo(24);
        make.left.mas_equalTo(9);
        make.centerY.mas_equalTo(0);
    }];
    
    //搜索TF
    NSString *tipStr = NSLocalizedString(@"Search_bar_tip",nil);
    _searchTF = [[UITextField alloc] init];
    _searchTF.backgroundColor = [UIColor clearColor];
    _searchTF.placeholder = tipStr;
    _searchTF.font = [UIFont systemFontOfSize:12];
    _searchTF.delegate = self;
    _searchTF.clearButtonMode = UITextFieldViewModeWhileEditing;
    [whiteBgView addSubview:_searchTF];

    [_searchTF mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(imageView.mas_right).offset(2);
        make.top.mas_equalTo(0);
        make.right.mas_equalTo(-5);
        make.bottom.mas_equalTo(0);
    }];
    
    //右边搜索有按钮
    NSString *titleStr = NSLocalizedString(@"Search_nas_title",nil);
    _searchButton = [[UIButton alloc] init];
    _searchButton.backgroundColor = [UIColor clearColor];
    [_searchButton setTitle:titleStr forState:UIControlStateNormal];
    [_searchButton setTitleColor:[UIColor hwColor:@"999999"] forState:UIControlStateDisabled];
    [_searchButton setTitleColor:[UIColor hwColor:@"#01B7EA"] forState:UIControlStateNormal];
    _searchButton.titleLabel.font = [UIFont systemFontOfSize:12.0];
    [_searchButton addTarget:self action:@selector(didClickSearchButFun) forControlEvents:UIControlEventTouchUpInside];
    [self addSubview:_searchButton];
    _searchButton.enabled = NO;

    [_searchButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(whiteBgView.mas_right).offset(2);
        make.top.mas_equalTo(0);
        make.right.mas_equalTo(0);
        make.bottom.mas_equalTo(0);
    }];
    
   
    
}

#pragma mark UITextFieldDelegate
- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string {
      NSString *beString = [textField.text stringByReplacingCharactersInRange:range withString:string];
    
    if([beString length] >0){
        _searchButton.enabled = YES;
    }
    else{
        _searchButton.enabled = NO;
    }
    
    if ([beString length] > 100) {
      textField.text = [beString substringToIndex:100];
      return NO;
    }
    return YES;
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField{
    [textField resignFirstResponder];
    return YES;
}

- (void)didClickSearchButFun{
    if (_didClickSearchFun) {
        NSString *string = _searchTF.text;
        _didClickSearchFun(string);
    }
    
    [_searchTF resignFirstResponder];
}

- (void)didClickWhiteViewFun
{
    if (_didClickBgFun) {
        _didClickBgFun();
    }
}

@end
