//
//  appInstallTypeView.m
//  Private-X
//
//  Created by xd h on 2025/3/13.
//

#import "appInstallTypeView.h"

@interface appInstallTypeView ()
{
    
}

@property(nonatomic,strong) UIView * selectBgView;

@end

@implementation appInstallTypeView

- (id)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    [self setBackgroundColor:[UIColor whiteColor]];
    [self drawAnyView];
    
    return self;
}

- (void)drawAnyView{
    CGFloat curButtonW = SCREEN_W/2.0;
    CGFloat curButtonH = 40.0;
    
    
    _installButton = [[UIButton alloc] init];
    _installButton.tag = 1;
    [_installButton setTitle:NSLocalizedString(@"nas_did_install_app_title",nil) forState:UIControlStateNormal];
    [_installButton setTitleColor:[UIColor hwColor:@"#666666" alpha:1.0] forState:UIControlStateNormal];
    [_installButton setTitleColor:[UIColor hwColor:@"#01B7EA" alpha:1.0] forState:UIControlStateSelected];
    _installButton.titleLabel.font = [UIFont boldSystemFontOfSize:14];
    [_installButton addTarget:self action:@selector(didClickButFun:) forControlEvents:UIControlEventTouchUpInside];
    [self addSubview:_installButton];
    
    [_installButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(0);
        make.width.mas_equalTo(curButtonW);
        make.top.mas_equalTo(0);
        make.height.mas_equalTo(curButtonH);
    }];
    
    _unInstallButton = [[UIButton alloc] init];
    _unInstallButton.tag = 2;
    [_unInstallButton setTitle:NSLocalizedString(@"nas_un_install_app_title",nil) forState:UIControlStateNormal];
    [_unInstallButton setTitleColor:[UIColor hwColor:@"#666666" alpha:1.0] forState:UIControlStateNormal];
    [_unInstallButton setTitleColor:[UIColor hwColor:@"#01B7EA" alpha:1.0] forState:UIControlStateSelected];
    _unInstallButton.titleLabel.font = [UIFont boldSystemFontOfSize:14];
    [_unInstallButton addTarget:self action:@selector(didClickButFun:) forControlEvents:UIControlEventTouchUpInside];
    [self addSubview:_unInstallButton];
    
    [_unInstallButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(curButtonW);
        make.width.mas_equalTo(curButtonW);
        make.top.mas_equalTo(0);
        make.height.mas_equalTo(curButtonH);
    }];
    
    UIView *lineView = [[UIView alloc] init];
    lineView.backgroundColor = [UIColor hwColor:@"#F9F9F9"];
    [self addSubview:lineView];
    
    [lineView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(0);
        make.right.mas_equalTo(0);
        make.height.mas_equalTo(1);
        make.bottom.mas_equalTo(0);
    }];
    
    _installButton.selected = YES;
    _selectBgView = [[UIView alloc] init];
    
    CAGradientLayer *gradientLayer = [CAGradientLayer layer];
    gradientLayer.frame = CGRectMake(0, 0, 60, 3);
    gradientLayer.colors = @[(__bridge NSString *)[UIColor hwColor:@"#0CDEFD" alpha:1.0].CGColor, (__bridge NSString *)[UIColor hwColor:@"#058DFB" alpha:1.0].CGColor];
    gradientLayer.locations = @[@(0), @(1.0f)];
    [_selectBgView.layer addSublayer:gradientLayer];
    
    //_selectBgView.backgroundColor = [UIColor whiteColor];
    _selectBgView.layer.cornerRadius = 1.5;
    [self insertSubview:_selectBgView atIndex:0];
    
    [_selectBgView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.mas_equalTo(_installButton.mas_centerX);
        make.width.mas_equalTo(60);
        make.height.mas_equalTo(3);
        make.bottom.mas_equalTo(0);
    }];
    
}

- (void)didClickButFun:(UIButton*)but
{
    NSInteger tag = but.tag;
    //but.selected = !but.selected;
    
    [self changeSelectViewIndex:tag];
    
    if(_didClickbuttonFun){
        _didClickbuttonFun(tag);
    }
}

- (void)changeSelectViewIndex:(NSInteger)index
{
    BOOL isSelectLeftType = YES;
    
    if(index == 2){
        isSelectLeftType = NO;
    }
    
    _installButton.selected = isSelectLeftType;
    _unInstallButton.selected = !isSelectLeftType;
    
    [_selectBgView mas_remakeConstraints:^(MASConstraintMaker *make) {
        if(isSelectLeftType){
            make.centerX.mas_equalTo(_installButton.mas_centerX);
        }
        else{
            make.centerX.mas_equalTo(_unInstallButton.mas_centerX);
        }
        make.width.mas_equalTo(60);
        make.height.mas_equalTo(3);
        make.bottom.mas_equalTo(0);
    }];
}

@end

